/*
    Copyright (C) 2000 by Hervé PHILIPPE <rv@ubix.org> (or <rv@bemail.org>)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "FenetreChangementDePartie.h"

  /////////////////////////////////////////////////
 // CONSTRUCTEUR de "FenetreChangementDePartie" //
/////////////////////////////////////////////////-----------------------------------------
// Affiche la fenêtre permettant de choisir le type des joueurs (humain, ordinateur...) --
//----------------------------------------------------------------------------------------
FenetreChangementDePartie::FenetreChangementDePartie(BWindow* fenetre_abalone, uint8* tableau_joueurs, uint8 niveau_ordinateur_maxi, uint8* ptr_nombre_joueurs, uint8* ptr_variante_du_jeu, uint8* ptr_variante_des_regles, TextesDuLogiciel* textes, bool nouvelle_partie)
// 8 PARAMETRES :									ENTREE/SORTIE (envoie message)	ENTREE/SORTIE				ENTREE						ENTREE/SORTIE				ENTREE/SORTIE					ENTREE/SORTIE					ENTREE					ENTREE
	: BWindow(POSITION_FENETRE_NOUVELLE_PARTIE, "", B_TITLED_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL, B_NOT_CLOSABLE | B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	BRect rect;
	BScreen ecran(fenetre_abalone);
	char chaine[100];
	int niveau;
	int i;

	if (nouvelle_partie == true)
		SetTitle(textes->Texte(1));
	else
		SetTitle(textes->Texte(2));
	m_NiveauOrdinateurMaxi = niveau_ordinateur_maxi;
	m_FenetreAbalone = fenetre_abalone;
	m_TableauJoueurs = tableau_joueurs;
	m_ptrNombreJoueurs = ptr_nombre_joueurs;
	m_NombreJoueursSauvegarde = *m_ptrNombreJoueurs;
	m_ptrVarianteDuJeu = ptr_variante_du_jeu;
	m_VarianteDuJeuSauvegarde = *m_ptrVarianteDuJeu;
	m_ptrVarianteDesRegles = ptr_variante_des_regles;
	m_VarianteDesReglesSauvegarde = *m_ptrVarianteDesRegles;
	m_NouvellePartie = nouvelle_partie;
	m_TableauJoueursSauvegarde = new uint8[NOMBRE_JOUEURS_MAXI];
	for (i=0; i < NOMBRE_JOUEURS_MAXI; i++)
		m_TableauJoueursSauvegarde[i] = m_TableauJoueurs[i];

	m_TableauGroupeJoueurs = new (BBox*)[NOMBRE_JOUEURS_MAXI];
//	if (NOMBRE_JOUEURS_MAXI == 2)
//		ResizeBy(150*NOMBRE_JOUEURS_MAXI, 20 * m_NiveauOrdinateurMaxi - 30);
//	else
	ResizeBy(149*NOMBRE_JOUEURS_MAXI - 2, 20 * m_NiveauOrdinateurMaxi);
	rect = ecran.Frame();
	MoveBy(rect.right/2 - Bounds().right/2, rect.bottom/2 - Bounds().bottom/2);

	rect = POSITION_BOUTON_COMMENCER_PARTIE;
	rect.top += 20 * m_NiveauOrdinateurMaxi;
	rect.bottom += 20 * m_NiveauOrdinateurMaxi;
	if (NOMBRE_JOUEURS_MAXI == 2) {
		rect.top -= 30;
		rect.bottom -= 30;
	}
	m_BoutonCommencer = new BButton(rect, textes->Texte(33), textes->Texte(33),
						new BMessage(MSG_OK), B_FOLLOW_ALL);
	m_BoutonCommencer->MakeDefault(true);
	rect.right = POSITION_BOUTON_ANNULER.right;
	rect.left = POSITION_BOUTON_ANNULER.left;
	m_BoutonAnnuler = new BButton(rect, textes->Texte(28), textes->Texte(28),
						new BMessage(MSG_ANNULER), B_FOLLOW_ALL);
	m_Fond = new BView(Bounds(), "Fond", B_FOLLOW_ALL, B_WILL_DRAW);




	rect = POSITION_GROUPE_JOUEURS;
	rect.right += 150*NOMBRE_JOUEURS_MAXI;
	rect.bottom += 20 * m_NiveauOrdinateurMaxi+15;
	if (NOMBRE_JOUEURS_MAXI == 2)
		rect.bottom -= 30;
	m_GroupeJoueurs = new BBox(rect,textes->Texte(31));
	m_GroupeJoueurs->SetLabel(textes->Texte(31));
	rect.top = rect.bottom + 8;
	rect.bottom = rect.top + 60;
	m_GroupeVariantes = new BBox(rect,textes->Texte(38));
	m_GroupeVariantes->SetLabel(textes->Texte(38));
	rect.top = rect.bottom + 8;
	rect.bottom = rect.top + 40;
	m_GroupeVariantesDesRegles = new BBox(rect,textes->Texte(44));
	m_GroupeVariantesDesRegles->SetLabel(textes->Texte(44));
	rect.left = 33;
	rect.top = 17;
	rect.right = rect.left + 290;
	rect.bottom = rect.top + 10;
	m_TableauBoutonsRadioVariantes = new (BRadioButton*)[NOMBRE_VARIANTES_MAXI];
	for (i=0; i < NOMBRE_VARIANTES_MAXI; i++) {
		m_TableauBoutonsRadioVariantes[i] = new BRadioButton(rect, textes->Texte(39+i), textes->Texte(39+i), new BMessage(MSG_VARIANTES+i));
		m_GroupeVariantes->AddChild(m_TableauBoutonsRadioVariantes[i]);

		if (i%2 == 0) {
			rect.top += 20;
			rect.bottom += 20;
		}
		else {
			rect.left += 270;
			rect.right += 270;
			rect.top -= 20;
			rect.bottom -= 20;
		}
	}
	m_TableauBoutonsRadioVariantes[*m_ptrVarianteDuJeu]->SetValue(1);

	rect.left = 33;
	rect.top = 15;
	rect.right = rect.left + 290;
	rect.bottom = rect.top + 10;
	m_TableauBoutonsRadioVariantesDesRegles = new (BRadioButton*)[NOMBRE_VARIANTES_REGLES_MAXI];
	for (i=0; i < NOMBRE_VARIANTES_REGLES_MAXI; i++) {
		m_TableauBoutonsRadioVariantesDesRegles[i] = new BRadioButton(rect, textes->Texte(45+i), textes->Texte(45+i), new BMessage(MSG_VARIANTES_REGLES+i));
		m_GroupeVariantesDesRegles->AddChild(m_TableauBoutonsRadioVariantesDesRegles[i]);
		rect.left += 270;
		rect.right += 270;
	}
	m_TableauBoutonsRadioVariantesDesRegles[*m_ptrVarianteDesRegles]->SetValue(1);

	m_TableauBoutonsRadio = new (BRadioButton**)[NOMBRE_JOUEURS_MAXI];
	for (i=0; i < NOMBRE_JOUEURS_MAXI; i++) {
		m_TableauBoutonsRadio[i] = new (BRadioButton*)[m_NiveauOrdinateurMaxi+1];	// +1 = HUMAIN
		sprintf(chaine, "%s%d", textes->Texte(32), i+1);
		rect = POSITION_GROUPE_JOUEUR1;
		rect.left += 148 * i;
		rect.right += 148 * i;
		rect.bottom += 20 * m_NiveauOrdinateurMaxi+10;
		m_TableauGroupeJoueurs[i] = new BBox(rect,chaine);
		m_TableauGroupeJoueurs[i]->SetLabel(chaine);
		niveau = 0;
		rect = POSITION_HUMAIN;
		m_TableauBoutonsRadio[i][0] = new BRadioButton(rect, textes->Texte(24), textes->Texte(24), new BMessage(MSG_HUMAIN_JOUEUR1+256*i+niveau));
		if (m_TableauJoueurs[i] == 0)
			m_TableauBoutonsRadio[i][0]->SetValue(1);
		m_TableauGroupeJoueurs[i]->AddChild(m_TableauBoutonsRadio[i][0]);

		for (niveau=1; niveau <= m_NiveauOrdinateurMaxi; niveau++) {
			rect.top += 20;
			rect.bottom += 20;
			sprintf(chaine, "%s %s %d", textes->Texte(25), textes->Texte(29), niveau);
			m_TableauBoutonsRadio[i][niveau] = new BRadioButton(rect, chaine, chaine, new BMessage(MSG_HUMAIN_JOUEUR1+256*i+niveau));
			if (m_TableauJoueurs[i] == niveau)
				m_TableauBoutonsRadio[i][niveau]->SetValue(1);
			m_TableauGroupeJoueurs[i]->AddChild(m_TableauBoutonsRadio[i][niveau]);
		}
		m_GroupeJoueurs->AddChild(m_TableauGroupeJoueurs[i]);
	}
	if (NOMBRE_JOUEURS_MAXI > 2) {
		m_TableauBoutonsRadioSelectionDuNombreDeJoueurs = new (BRadioButton*)[NOMBRE_JOUEURS_MAXI-1];
		for (i=0; i < NOMBRE_JOUEURS_MAXI-1; i++) {
			rect = POSITION_RADIO_2JOUEURS;
			rect.top += 20 * m_NiveauOrdinateurMaxi;
			rect.bottom += 20 * m_NiveauOrdinateurMaxi+15;
			rect.left += 70 * i;
			rect.right += 70 * i;
			sprintf(chaine, "%d %s", i+2, textes->Texte(30));
			m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[i] = new BRadioButton(rect, chaine, chaine, new BMessage(MSG_2JOUEURS+i));
			m_GroupeJoueurs->AddChild(m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[i]);
			if (*m_ptrNombreJoueurs == 2 + i)
				m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[i]->SetValue(1);

			if (nouvelle_partie == false && m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[i]->Value() != 1)
				m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[i]->SetEnabled(false);
		}
	}

	m_TableauGroupeEquipes = new (BBox*)[NOMBRE_EQUIPES_MAXI];
	for (i=0; i < NOMBRE_EQUIPES_MAXI; i++) {
		rect = POSITION_GROUPE_JOUEUR1;
		rect.left += 300 * i - 1;
		rect.right += 300 * i + 159;
		rect.top -= 9;
		rect.bottom += 20 * m_NiveauOrdinateurMaxi+24;
		sprintf(chaine, "%s%d", textes->Texte(47), i+1);
		m_TableauGroupeEquipes[i] = new BBox(rect,chaine);
		m_TableauGroupeEquipes[i]->SetLabel(chaine);
	}

	m_Fond->AddChild(m_GroupeJoueurs);
	GriserJoueurs();
	if (nouvelle_partie == false) {
		for (i=0; i < NOMBRE_VARIANTES_MAXI; i++)
			if (m_TableauBoutonsRadioVariantes[i]->Value() != 1)
				m_TableauBoutonsRadioVariantes[i]->SetEnabled(false);
		for (i=0; i < NOMBRE_VARIANTES_REGLES_MAXI; i++)
			if (m_TableauBoutonsRadioVariantesDesRegles[i]->Value() != 1)
				m_TableauBoutonsRadioVariantesDesRegles[i]->SetEnabled(false);
	}
	m_Fond->AddChild(m_GroupeVariantes);
	m_Fond->AddChild(m_GroupeVariantesDesRegles);
	m_Fond->AddChild(m_BoutonCommencer);
	m_Fond->AddChild(m_BoutonAnnuler);
	m_Fond->SetViewColor(216,216,216);
	AddChild(m_Fond);
	Show();
}

  ////////////////////////////////////////////////
 // DESTRUCTEUR de "FenetreChangementDePartie" //
////////////////////////////////////////////////-------
// Détruit les tableaux alloués dans le constructeur --
//-----------------------------------------------------
FenetreChangementDePartie::~FenetreChangementDePartie()
// AUCUN PARAMETRE
{
	int niveau;
	int i;

	for (i=0; i < NOMBRE_EQUIPES_MAXI; i++) {
		if (m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[2]->Value() != 0)
			m_Fond->RemoveChild(m_TableauGroupeEquipes[i]);
		delete m_TableauGroupeEquipes[i];
	}
	delete[] m_TableauGroupeEquipes;

	for (i=0; i < NOMBRE_VARIANTES_MAXI; i++) {
		m_GroupeVariantes->RemoveChild(m_TableauBoutonsRadioVariantes[i]);
		delete m_TableauBoutonsRadioVariantes[i];
	}
	delete[] m_TableauBoutonsRadioVariantes;

	for (i=0; i < NOMBRE_VARIANTES_REGLES_MAXI; i++) {
		m_GroupeVariantesDesRegles->RemoveChild(m_TableauBoutonsRadioVariantesDesRegles[i]);
		delete m_TableauBoutonsRadioVariantesDesRegles[i];
	}
	delete[] m_TableauBoutonsRadioVariantesDesRegles;

	if (NOMBRE_JOUEURS_MAXI > 2) {
		for (i=0; i < NOMBRE_JOUEURS_MAXI-1; i++) {
			m_GroupeJoueurs->RemoveChild(m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[i]);
			delete m_TableauBoutonsRadioSelectionDuNombreDeJoueurs[i];
		}
		delete[] m_TableauBoutonsRadioSelectionDuNombreDeJoueurs;
	}
	for (i=0; i < NOMBRE_JOUEURS_MAXI; i++) {
		for (niveau=0; niveau <= m_NiveauOrdinateurMaxi; niveau++) {
			m_TableauGroupeJoueurs[i]->RemoveChild(m_TableauBoutonsRadio[i][niveau]);
			delete m_TableauBoutonsRadio[i][niveau];
		}
		delete[] m_TableauBoutonsRadio[i];
		m_GroupeJoueurs->RemoveChild(m_TableauGroupeJoueurs[i]);
		delete m_TableauGroupeJoueurs[i];
	}
	delete[] m_TableauBoutonsRadio;
	delete[] m_TableauGroupeJoueurs;
	delete[] m_TableauJoueursSauvegarde;
	m_Fond->RemoveChild(m_GroupeJoueurs);
	delete m_GroupeJoueurs;
	m_Fond->RemoveChild(m_GroupeVariantes);
	delete m_GroupeVariantes;
	m_Fond->RemoveChild(m_GroupeVariantesDesRegles);
	delete m_GroupeVariantesDesRegles;
	m_Fond->RemoveChild(m_BoutonCommencer);
	delete m_BoutonCommencer;
	m_Fond->RemoveChild(m_BoutonAnnuler);
	delete m_BoutonAnnuler;
	RemoveChild(m_Fond);
	delete m_Fond;
}

  ////////////////////////////////
 // FONCTION "MessageReceived" //
////////////////////////////////--------------------------------------
// Reçoit et traite tous les messages pour la gestion de la fenêtre --
//--------------------------------------------------------------------
void		// AUCUNE VALEUR DE RETOUR
FenetreChangementDePartie::MessageReceived(BMessage* message)
// 1 PARAMETRE :								ENTREE
{
	int i, j;

	switch(message->what)
	{
		case MSG_OK:
			if (m_FenetreAbalone->Lock()) {
				if (m_NouvellePartie == true)
					m_FenetreAbalone->PostMessage(MSG_COMMENCER_NOUVELLE_PARTIE);
				else
					m_FenetreAbalone->PostMessage(MSG_COMMENCER_PARTIE);
				m_FenetreAbalone->Unlock();
			}
		break;
		case MSG_ANNULER:
			for (i=0; i < NOMBRE_JOUEURS_MAXI; i++)
				m_TableauJoueurs[i] = m_TableauJoueursSauvegarde[i];
			*m_ptrNombreJoueurs = m_NombreJoueursSauvegarde;
			*m_ptrVarianteDuJeu = m_VarianteDuJeuSauvegarde;
			*m_ptrVarianteDesRegles = m_VarianteDesReglesSauvegarde;
			PostMessage(B_QUIT_REQUESTED);
		break;
		default:
			for (i=0; i < NOMBRE_JOUEURS_MAXI; i++) {
				if (message->what >= uint32(MSG_HUMAIN_JOUEUR1+256*i) && message->what <= uint32(MSG_HUMAIN_JOUEUR1+256*i+m_NiveauOrdinateurMaxi))
					m_TableauJoueurs[i] = message->what - MSG_HUMAIN_JOUEUR1-256*i;
				if (*m_ptrNombreJoueurs != 2+i && message->what == uint32(MSG_2JOUEURS+i)) {
					if (*m_ptrNombreJoueurs == 4 && i != 2) {
						for (j=0; j < NOMBRE_EQUIPES_MAXI; j++) {
							m_Fond->RemoveChild(m_TableauGroupeEquipes[j]);
							m_TableauGroupeJoueurs[j*2+1]->MoveBy(7-j*4,0);
						}
					m_TableauGroupeJoueurs[1]->MoveBy(-159,0);
					m_TableauGroupeJoueurs[2]->MoveBy(-4+159,0);
					}
					*m_ptrNombreJoueurs = 2 + i;
					GriserJoueurs();
				}
			}
			if (m_NouvellePartie == true) {
				if (message->what >= uint32(MSG_VARIANTES) && message->what < uint32(MSG_VARIANTES+NOMBRE_VARIANTES_MAXI))
					*m_ptrVarianteDuJeu = (uint8)(message->what - MSG_VARIANTES);
				else
					if (message->what >= uint32(MSG_VARIANTES_REGLES) && message->what < uint32(MSG_VARIANTES_REGLES+NOMBRE_VARIANTES_REGLES_MAXI))
						*m_ptrVarianteDesRegles = (uint8)(message->what - MSG_VARIANTES_REGLES);
			}
	}

}

  /////////////////////
 // FONCTION "Quit" //
/////////////////////-
// Ferme la fenêtre --
//--------------------
void		// AUCUNE VALEUR DE RETOUR
FenetreChangementDePartie::Quit()
// AUCUN PARAMETRE
{
	BWindow::Quit();
}

  //////////////////////////////
 // FONCTION "GriserJoueurs" //
//////////////////////////////-----------
// Grise les joueurs qui ne jouent pas --
//---------------------------------------
void		// AUCUNE VALEUR DE RETOUR
FenetreChangementDePartie::GriserJoueurs()
// AUCUN PARAMETRE
{
	int i, j, niveau;
	bool grise;

	for (i=0; i < NOMBRE_JOUEURS_MAXI; i++) {
		grise = i < *m_ptrNombreJoueurs;
		for (niveau=0; niveau <= m_NiveauOrdinateurMaxi; niveau++)
			m_TableauBoutonsRadio[i][niveau]->SetEnabled(grise);
		if (i == 3 && grise == true) {
			for (j=0; j < NOMBRE_EQUIPES_MAXI; j++) {
				m_Fond->AddChild(m_TableauGroupeEquipes[j]);
				m_TableauGroupeJoueurs[j*2+1]->MoveBy(-7+j*4,0);
			}
			m_TableauGroupeJoueurs[1]->MoveBy(159,0);
			m_TableauGroupeJoueurs[2]->MoveBy(4-159,0);
		}
	}
	grise = (*m_ptrNombreJoueurs) > 2;
	if (grise && (*m_ptrVarianteDuJeu) > 1) {
		*m_ptrVarianteDuJeu = 0;
		m_TableauBoutonsRadioVariantes[0]->SetValue(1);
	}
	m_TableauBoutonsRadioVariantes[2]->SetEnabled(!grise);
	m_TableauBoutonsRadioVariantes[3]->SetEnabled(!grise);
//m_ptrNombreJoueurs;
}
