/*
    Copyright (C) 2000 by Hervé PHILIPPE <rv@ubix.org> (or <rv@bemail.org>)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _FENETRECHANGEMENTDEPARTIE_H_
#define _FENETRECHANGEMENTDEPARTIE_H_

#include <Application.h>
#include <Window.h>
#include <Button.h>
#include <Box.h>
#include <RadioButton.h>
#include <Message.h>
#include <Screen.h>
#include <stdio.h>

#include "PlateauDeJeu.h"		// Pour NOMBRE_JOUEURS_MAXI
#include "TextesDuLogiciel.h"

#define NOMBRE_EQUIPES_MAXI					2

#define POSITION_FENETRE_NOUVELLE_PARTIE	BRect(0,0,15,285)
#define POSITION_GROUPE_JOUEURS				BRect(8, 6, 17, 100)
#define POSITION_GROUPE_JOUEUR1				BRect(18, 30,148, 60)
#define POSITION_HUMAIN						BRect(8, 15, 128, 25)
#define POSITION_BOUTON_COMMENCER_PARTIE	BRect(330, 245, 460, 275)
#define POSITION_BOUTON_ANNULER				BRect(180, 245, 280, 275)
#define POSITION_RADIO_2JOUEURS				BRect(190, 85, 260, 90)

#define MSG_OK							'OKCO'
#define MSG_COMMENCER_PARTIE			'COMP'
#define MSG_COMMENCER_NOUVELLE_PARTIE	'COMD'
#define MSG_COMMENCER_PARTIE			'COMP'
#define MSG_ANNULER						'ANNU'
#define MSG_HUMAIN_JOUEUR1				'0J00'	// 1er joueur :		'0J00'...'0J03'
												// 2ième joueur :	'0J10'...'0J13'	etc.
#define MSG_2JOUEURS					'JOU2'	// 2 joueurs : 'JOU2', 3joueurs : 'JOU3'...
#define MSG_VARIANTES					'VA00'
#define NOMBRE_VARIANTES_MAXI			4
#define MSG_VARIANTES_REGLES			'VR00'
#define NOMBRE_VARIANTES_REGLES_MAXI	2

class FenetreChangementDePartie : public BWindow
{
// FONCTIONS
	public:
						FenetreChangementDePartie(BWindow* fenetre_abalone, uint8* tableau_joueurs, uint8 niveau_ordinateur_maxi, uint8* ptr_variante_du_jeu, uint8* ptr_variante_des_regles, uint8* ptr_nombre_joueurs, TextesDuLogiciel* textes, bool nouvelle_partie);
		virtual			~FenetreChangementDePartie();
		virtual	void	MessageReceived(BMessage* message);
		void			Quit();
		void			GriserJoueurs();
	private:

// VARIABLES ET CONSTANTES
	private:
		BView*					m_Fond;
		BBox*					m_GroupeJoueurs;
		BBox**					m_TableauGroupeJoueurs;
		BBox**					m_TableauGroupeEquipes;
		BButton*				m_BoutonCommencer;
		BButton*				m_BoutonAnnuler;
		BRadioButton***			m_TableauBoutonsRadio;
		BRadioButton**			m_TableauBoutonsRadioSelectionDuNombreDeJoueurs;
		BBox*					m_GroupeVariantes;
		BRadioButton**			m_TableauBoutonsRadioVariantes;
		BBox*					m_GroupeVariantesDesRegles;
		BRadioButton**			m_TableauBoutonsRadioVariantesDesRegles;
		BWindow*				m_FenetreAbalone;
		uint8*					m_ptrNombreJoueurs;
		uint8					m_NombreJoueursSauvegarde;
		uint8*					m_ptrVarianteDuJeu;
		uint8					m_VarianteDuJeuSauvegarde;
		uint8*					m_ptrVarianteDesRegles;
		uint8					m_VarianteDesReglesSauvegarde;
		uint8*					m_TableauJoueurs;
		uint8*					m_TableauJoueursSauvegarde;
		uint8					m_NiveauOrdinateurMaxi;
		bool					m_NouvellePartie;
};

#endif